import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React, { useMemo } from 'react';
import classnames from 'classnames';
import uniqueId from 'lodash/uniqueId';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { Typography } from '@highlight-ui/typography';
import styles from './Checkbox.module.scss.js'; // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

var CheckboxWithRef = function (_a, ref) {
  var label = _a.label,
      subLabel = _a.subLabel,
      className = _a.className,
      metadata = _a.metadata,
      id = _a.id,
      disabled = _a.disabled,
      checkboxProps = __rest(_a, ["label", "subLabel", "className", "metadata", "id", "disabled"]);

  var generatedId = useMemo(function () {
    return uniqueId('checkbox-');
  }, []);
  var inputId = id || generatedId;
  return /*#__PURE__*/React.createElement("span", __assign({
    className: classnames(className, styles.checkbox)
  }, parseMetadata(metadata)), /*#__PURE__*/React.createElement("input", __assign({
    ref: ref,
    id: inputId,
    type: "checkbox",
    disabled: disabled,
    className: styles.checkboxInput
  }, checkboxProps, parseMetadata(suffixMetadata(metadata, 'input')))), /*#__PURE__*/React.createElement("label", __assign({
    htmlFor: inputId,
    className: styles.checkboxLabel
  }, parseMetadata(suffixMetadata(metadata, 'label'))), label && /*#__PURE__*/React.createElement(Typography, {
    title: label,
    variant: "body-1",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-default',
    className: styles.checkboxLabelText
  }, label)), label && subLabel && /*#__PURE__*/React.createElement(Typography, __assign({
    title: subLabel,
    variant: "caption-2",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-subdued',
    className: styles.checkboxSubLabel
  }, parseMetadata(suffixMetadata(metadata, 'sub-label'))), subLabel));
};

CheckboxWithRef.displayName = 'Checkbox';
var Checkbox = /*#__PURE__*/React.forwardRef(CheckboxWithRef);
export { Checkbox as default };
//# sourceMappingURL=Checkbox.js.map
